#ifndef GLWIDGET_H
#define GLWIDGET_H

class QOpenGLShaderProgram;
class QTimerEvent;

#include <QMatrix4x4>
#include <QOpenGLWidget>
#include <QOpenGLFunctions>

class GLWidget : public QOpenGLWidget, public QOpenGLFunctions {
public:
    explicit GLWidget(QWidget *parent = 0);
    ~GLWidget();

private:
    QOpenGLShaderProgram * m_program;
    QMatrix4x4 m_matrix;
    GLuint m_IBO;
    GLuint m_vertexDataVBO;
    GLuint m_texture;
    GLuint m_matrixPos;
    GLuint m_texturePos;
    GLuint m_vertexPos;
    GLuint m_texCoordPos;
    bool m_isRotating;

    void initializeGL();
    void resizeGL(int w, int h);
    void paintGL();
    void timerEvent(QTimerEvent *event);
    void mousePressEvent(QMouseEvent *event);

    QImage drawImage(const QString &txt);
};

#endif // GLWIDGET_H
